#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "Common_openmp.h"

int main ( int argc, char* argv[] ) {

//Locals

  char help_message[1000] = 
"MaxSSmap version 1.0 (Jan 2014) maps DNA to genomes sequences\n\ 
with a maximum scoring subsequence strategy. MaxSSmap is written\n\ 
by Usman Roshan. For DNA to genome mapping \n\n\ 
Usage: For DNA to genome mapping ./MaxSSmap dnagenome <options>\n\ 
Please contact usman@cs.njit.edu for support and additional information\n";

  if(argc == 1) { printf(help_message); exit(EXIT_SUCCESS); }
  if(!strcmp(argv[1], "dnagenome")) DNAGenome(argc, argv);
//  else if(!strcmp(argv[1], "dbsearch")) DBSearch(argc, argv);
//  else { printf("Please specify dnagenome or dbsearch (see GPU_MaxSSmap -h)"); exit(EXIT_FAILURE); }
  else { printf("Please specify dnagenome (see MaxSSmap -h)"); exit(EXIT_FAILURE); }

  return 0;
}

