#include "Common_openmp.h"

extern int subst_index[LETTERS];
extern float pos_specific_scores[MAXQLEN * BASES + BASES + PSS_OFFSET];

void maxssmap_openmp(int jobs_todo, char* database, float* results, int FRAGMENTSIZE, int QLEN) {

  int id = omp_get_thread_num();

  if(id < jobs_todo) {
    int j_, j, i, stop, k;
    unsigned int p;
    float score[16], max=0;
    char ch;
    char* ch_;

    stop = QLEN/16; stop = stop*16;

//    printf("Hello from thread %d, QLEN=%d FRAGMENTSIZE=%d\n", id, QLEN, FRAGMENTSIZE);

    for(i = 0; i < FRAGMENTSIZE; i += 16){
      p = i;
      score[0] = 0; score[1] = 0; score[2] = 0; score[3] = 0; 
      score[4] = 0; score[5] = 0; score[6] = 0; score[7] = 0; 
      score[8] = 0; score[9] = 0; score[10] = 0; score[11] = 0; 
      score[12] = 0; score[13] = 0; score[14] = 0; score[15] = 0; 
/*      score[16] = 0; score[17] = 0; score[18] = 0; score[19] = 0; 
      score[20] = 0; score[21] = 0; score[22] = 0; score[23] = 0;
      score[24] = 0; score[25] = 0; score[26] = 0; score[27] = 0; 
      score[28] = 0; score[29] = 0; score[30] = 0; score[31] = 0; */
      for(j_ = 0; j_ < stop; j_ += 1){
//	if(j_/16 + i >= (k+1)*FRAGMENTSIZE/16) { p = 0; k++; } 
	if(j_ + i >= (k+1)*FRAGMENTSIZE) { k++; } 
	ch = database[p + id*FRAGMENTSIZE]; 
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[j_*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE]; 
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j]; 
        score[3] += pos_specific_scores[(j_-3)*BASES + j]; 
        score[4] += pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j];
        score[31] += pos_specific_scores[(j_-31)*BASES + j];  */
        j_++; p++;

	ch = database[p + id*FRAGMENTSIZE]; 
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j]; 
        score[4] += pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];   
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j];   
        score[30] += pos_specific_scores[(j_-30)*BASES + j];   
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];  
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];  
        score[7] += pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;
 
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; p++;

/*
        ch = database[p + id*FRAGMENTSIZE];
        j = subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += pos_specific_scores[(j_)*BASES + j];
        score[1] += pos_specific_scores[(j_-1)*BASES + j];
        score[2] += pos_specific_scores[(j_-2)*BASES + j];
        score[3] += pos_specific_scores[(j_-3)*BASES + j];
        score[4] += pos_specific_scores[(j_-4)*BASES + j];
        score[5] += pos_specific_scores[(j_-5)*BASES + j];
        score[6] += pos_specific_scores[(j_-6)*BASES + j];
        score[7] += pos_specific_scores[(j_-7)*BASES + j];
        score[8] += pos_specific_scores[(j_-8)*BASES + j];
        score[9] += pos_specific_scores[(j_-9)*BASES + j];
        score[10] += pos_specific_scores[(j_-10)*BASES + j];
        score[11] += pos_specific_scores[(j_-11)*BASES + j];
        score[12] += pos_specific_scores[(j_-12)*BASES + j];
        score[13] += pos_specific_scores[(j_-13)*BASES + j];
        score[14] += pos_specific_scores[(j_-14)*BASES + j];
        score[15] += pos_specific_scores[(j_-15)*BASES + j];
        score[16] += pos_specific_scores[(j_-16)*BASES + j];
        score[17] += pos_specific_scores[(j_-17)*BASES + j];
        score[18] += pos_specific_scores[(j_-18)*BASES + j];
        score[19] += pos_specific_scores[(j_-19)*BASES + j];
        score[20] += pos_specific_scores[(j_-20)*BASES + j];
        score[21] += pos_specific_scores[(j_-21)*BASES + j];
        score[22] += pos_specific_scores[(j_-22)*BASES + j];
        score[23] += pos_specific_scores[(j_-23)*BASES + j];
        score[24] += pos_specific_scores[(j_-24)*BASES + j];
        score[25] += pos_specific_scores[(j_-25)*BASES + j];
        score[26] += pos_specific_scores[(j_-26)*BASES + j];
        score[27] += pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += pos_specific_scores[(j_-28)*BASES + j];
        score[29] += pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += pos_specific_scores[(j_-31)*BASES + j]; */
        p++;

        score[0] = score[0] > 0 ? score[0] : 0; score[1] = score[1] > 0 ? score[1] : 0;
        score[2] = score[2] > 0 ? score[2] : 0; score[3] = score[3] > 0 ? score[3] : 0;
        score[4] = score[4] > 0 ? score[4] : 0; score[5] = score[5] > 0 ? score[5] : 0;
        score[6] = score[6] > 0 ? score[6] : 0; score[7] = score[7] > 0 ? score[7] : 0;
        score[8] = score[8] > 0 ? score[8] : 0; score[9] = score[9] > 0 ? score[9] : 0;
        score[10] = score[10] > 0 ? score[10] : 0; score[11] = score[11] > 0 ? score[11] : 0;
        score[12] = score[12] > 0 ? score[12] : 0; score[13] = score[13] > 0 ? score[13] : 0;
        score[14] = score[14] > 0 ? score[14] : 0; score[15] = score[15] > 0 ? score[15] : 0;
/*        score[16] = score[16] > 0 ? score[16] : 0; score[17] = score[17] > 0 ? score[17] : 0;
        score[18] = score[18] > 0 ? score[18] : 0; score[19] = score[19] > 0 ? score[19] : 0; 
        score[20] = score[20] > 0 ? score[20] : 0; score[21] = score[21] > 0 ? score[21] : 0;
        score[22] = score[22] > 0 ? score[22] : 0; score[23] = score[23] > 0 ? score[23] : 0;
        score[24] = score[24] > 0 ? score[24] : 0; score[25] = score[25] > 0 ? score[25] : 0;
        score[26] = score[26] > 0 ? score[26] : 0; score[27] = score[27] > 0 ? score[27] : 0; 
        score[28] = score[28] > 0 ? score[28] : 0; score[29] = score[29] > 0 ? score[29] : 0; 
        score[30] = score[30] > 0 ? score[30] : 0; score[31] = score[31] > 0 ? score[31] : 0; */

        max = score[0] > max ? score[0] : max; max = score[1] > max ? score[1] : max;
        max = score[2] > max ? score[2] : max; max = score[3] > max ? score[3] : max;
        max = score[4] > max ? score[4] : max; max = score[5] > max ? score[5] : max;
        max = score[6] > max ? score[6] : max; max = score[7] > max ? score[7] : max;
        max = score[8] > max ? score[8] : max; max = score[9] > max ? score[9] : max;
        max = score[10] > max ? score[10] : max; max = score[11] > max ? score[11] : max;
        max = score[12] > max ? score[12] : max; max = score[13] > max ? score[13] : max;
        max = score[14] > max ? score[14] : max; max = score[15] > max ? score[15] : max;
/*        max = score[16] > max ? score[16] : max; max = score[17] > max ? score[17] : max;
        max = score[18] > max ? score[18] : max; max = score[19] > max ? score[19] : max; 
        max = score[20] > max ? score[20] : max; max = score[21] > max ? score[21] : max;
        max = score[22] > max ? score[22] : max; max = score[23] > max ? score[23] : max;
        max = score[24] > max ? score[24] : max; max = score[25] > max ? score[25] : max;
        max = score[26] > max ? score[26] : max; max = score[27] > max ? score[27] : max; 
        max = score[28] > max ? score[28] : max; max = score[29] > max ? score[29] : max; 
        max = score[30] > max ? score[30] : max; max = score[31] > max ? score[31] : max; */

//        printf("max=%f from thread %d\n", max, id);

      }

    }

    results[id] = max;

  } 
}

